package edu.buffalo.nsf.hippo.data.query;

import java.util.Collections;
import java.util.Map;

public abstract class WhereComparator
{
    public abstract String toSQLString (Map params);
    public String toString()
    {
        return toSQLString(Collections.EMPTY_MAP);
    }

    public static final WhereComparator NEQ = 
        new WhereComparator() {
            public String toSQLString(Map params)
            {
                return "<>";
            }
        };

    public static final WhereComparator EQ = 
        new WhereComparator() {
            public String toSQLString(Map params)
            {
                return "=";
            }
        };

    public static final WhereComparator LE = 
        new WhereComparator() {
            public String toSQLString(Map params)
            {
                return "<";
            }
        };

    public static final WhereComparator GE = 
        new WhereComparator() {
            public String toSQLString(Map params)
            {
                return ">";
            }
        };

    public static final WhereComparator IS = 
        new WhereComparator() {
            public String toSQLString(Map params)
            {
                return "IS";
            }
        };
}
